# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: frequenz/api/common/metrics/electrical.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass

import betterproto

from ... import metrics as __metrics__


@dataclass(eq=False, repr=False)
class Dc(betterproto.Message):
    """Metrics of a DC electrical connection."""

    voltage: "__metrics__.Metric" = betterproto.message_field(1)
    """The DC voltage across the component. In Volt (V)."""

    current: "__metrics__.Metric" = betterproto.message_field(2)
    """
    The DC current flowing away from the grid connection. In passive sign
    convention: +ve current means consumption, away from the grid. -ve current
    means supply into the grid. In Ampere (A).
    """

    power: "__metrics__.Metric" = betterproto.message_field(3)
    """
    The DC power flowing away from the grid connection. In passive sign
    convention: +ve power means consumption, away from the grid. -ve power
    means supply into the grid. In Watt (W).
    """


@dataclass(eq=False, repr=False)
class Ac(betterproto.Message):
    """
    The current state and metrics of the electrical connections to the
    inverter.
    """

    frequency: "__metrics__.Metric" = betterproto.message_field(1)
    """The AC frequency. In Hertz (Hz)."""

    current: "__metrics__.Metric" = betterproto.message_field(2)
    """
    The apparent 3-phase AC current. Positive values represent apparent energy
    flowing towards the grid connection, and vice versa. In Ampere (A).
    """

    power_apparent: "__metrics__.Metric" = betterproto.message_field(3)
    """
    The apparent 3-phase AC power. Positive values represent apparent energy
    flowing towards the grid connection, and vice versa. In Volt-Ampere (VA).
    """

    power_active: "__metrics__.Metric" = betterproto.message_field(4)
    """
    The total active 3-phase AC active power. +ve power means consumption, away
    from the grid. -ve power means supply into the grid. In Watt (W).
    """

    power_reactive: "__metrics__.Metric" = betterproto.message_field(5)
    """
    The reactive 3-phase AC power. +ve power means capacitive (current leading
    w.r.t. voltage). -ve power means inductive (current lagging w.r.t.
    voltage). In Volt-Ampere reactive (VAr).
    """

    energy_apparent: "__metrics__.Metric" = betterproto.message_field(6)
    """
    The total 3-phase apparent energy. A positive value represents the net
    apparent energy supplied to the grid connection, and vice versa. In Volt-
    Ampere-hour (VAh).
    """

    energy_active: "AcActiveEnergy" = betterproto.message_field(7)
    """
    The total 3-phase active energy counters for the underlying component's
    consumption and supply. In Watt-hour (Wh).
    """

    energy_reactive: "AcReactiveEnergy" = betterproto.message_field(8)
    """
    The total 3-phase reactive energy counters for the underlying component's
    capacitive and inductive energy values. In Volt-Ampere reactive hour
    (VArh). FIXME: ReactiveEnergy says Volt-Ampere-hour (VAh).
    """

    harmonics_power_active: "AcHarmonics" = betterproto.message_field(9)
    """
    The sums of the harmonics of the instantaneous active power at the
    component across all 3 phases.
    """

    thd_power_active: float = betterproto.float_field(10)
    """
    The sums of the total harmonic distortion of the instantaneous active power
    at the component across all 3 phases.
    """

    phase_1: "AcAcPhase" = betterproto.message_field(11)
    """AC metrics for phase/line 1."""

    phase_2: "AcAcPhase" = betterproto.message_field(12)
    """AC metrics for phase/line 2."""

    phase_3: "AcAcPhase" = betterproto.message_field(13)
    """AC metrics for phase/line 3."""


@dataclass(eq=False, repr=False)
class AcActiveEnergy(betterproto.Message):
    """The active energy the inverter is consuming or generating."""

    energy: "__metrics__.Metric" = betterproto.message_field(1)
    """
    The sum of the consumed and delivered energy. This is a signed value in
    passive sign convention: if more energy is consumed than delivered, this is
    a -ve number, otherwise +ve. In Watt-hour (Wh).
    """

    energy_consumed: "__metrics__.Metric" = betterproto.message_field(2)
    """The consumed energy. In Watt-hour (Wh)."""

    energy_delivered: "__metrics__.Metric" = betterproto.message_field(3)
    """The delivered energy. In Watt-hour (Wh)."""


@dataclass(eq=False, repr=False)
class AcReactiveEnergy(betterproto.Message):
    """The reactive energy the inverter is consuming or generating."""

    energy: "__metrics__.Metric" = betterproto.message_field(1)
    """
    The sum of the capacitive and inductive energy. This is a signed value. If
    more energy is capacitive than inductive, this is a -ve number, otherwise
    +ve. In Volt-Ampere-hour (VArh).
    """

    energy_capacitive: "__metrics__.Metric" = betterproto.message_field(2)
    """The capacitive energy. In Volt-Ampere-hour (VArh)."""

    energy_inductive: "__metrics__.Metric" = betterproto.message_field(3)
    """The inductive energy. In Volt-Ampere-hour (VArh)."""


@dataclass(eq=False, repr=False)
class AcHarmonics(betterproto.Message):
    """
    The harmonics of the fast Fourier transform of the instantaneous values and
    its total harmonic distortion. In percent (%).
    """

    harmonic_1: float = betterproto.float_field(1)
    harmonic_2: float = betterproto.float_field(2)
    harmonic_3: float = betterproto.float_field(3)
    harmonic_4: float = betterproto.float_field(4)
    harmonic_5: float = betterproto.float_field(5)
    harmonic_6: float = betterproto.float_field(6)
    harmonic_7: float = betterproto.float_field(7)
    harmonic_8: float = betterproto.float_field(8)
    harmonic_9: float = betterproto.float_field(9)
    harmonic_10: float = betterproto.float_field(10)
    harmonic_11: float = betterproto.float_field(11)


@dataclass(eq=False, repr=False)
class AcAcPhase(betterproto.Message):
    """AC metrics of a single phase."""

    voltage: "__metrics__.Metric" = betterproto.message_field(1)
    """The AC voltage between the line and the neutral wire. In Volt (V)."""

    current: "__metrics__.Metric" = betterproto.message_field(2)
    """
    AC current. +ve current means consumption, away from the grid. -ve current
    means supply into the grid. In Ampere (A).
    """

    power_active: "__metrics__.Metric" = betterproto.message_field(3)
    """
    AC active power. +ve power means consumption, away from the grid. -ve power
    means supply into the grid. In Watt (W).
    """

    power_reactive: "__metrics__.Metric" = betterproto.message_field(4)
    """
    AC reactive power. +ve power means inductive (leading). -ve power means
    capacitive (lagging). In Volt-Ampere reactive (VAr).
    """

    energy_apparent: "__metrics__.Metric" = betterproto.message_field(5)
    """
    The total apparent energy. A Positive value represents the net apparent
    energy supplied to the grid connection, and vice versa. In Volt-Ampere-hour
    (VAh).
    """

    energy_active: "AcActiveEnergy" = betterproto.message_field(6)
    """
    The total active energy counters for the underlying component's consumption
    and supply. In Watt-hour (Wh).
    """

    energy_reactive: "AcReactiveEnergy" = betterproto.message_field(7)
    """
    The total reactive energy counters for the underlying component's
    capacitive and inductive energy values. In Volt-Ampere reactive hour
    (VArh).
    """

    harmonics_power_active: "AcHarmonics" = betterproto.message_field(8)
    """
    Harmonics of the instantaneous active power at the component. In percent
    (%).
    """

    thd_power_active: float = betterproto.float_field(9)
    """
    Total harmonic distortion of the instantaneous active power at the
    component. In percent (%).
    """
